# Wyszukiwanie binarne: znajduje w tablicy X indeks s
# największy taki, że X[s]<=X[k]-D.
def znajdz(X, k, D):
  poczatek = 0
  koniec = len(X)
  while poczatek < koniec:
    srodek = (poczatek + koniec + 1) // 2
    if X[srodek] > X[k] - D:
      koniec = srodek - 1
    else:
      poczatek = srodek
  return poczatek

# Liczby N i D jak w treści zadania.
(N, D) = tuple(map(int, input().split()))

# Ciągi X[i], C[i] jak w treści zadania.
# X[0] = 0 dla wygody późniejszego wyszukiwania.
# A następnie wczytujemy X[1], ..., X[N]
X = [0] + list(map(int, input().split()))
# Wczytujemy C[1], ..., C[N]
C = [0] + list(map(int, input().split()))

# P[0] = 0 zgodnie z ustaleniami.
P = [0 for _ in range(N + 1)]
# Wyliczamy sumy prefiksowe P[1], ..., P[N].
for k in range(1, N + 1):
  P[k] = P[k - 1] + C[k]

koszt = [0 for _ in range(N + 1)]
podpowiedz = [0 for _ in range(N + 1)]
# Zaczynamy pętlę programowania dynamicznego.
for k in range(N + 1):
  s = znajdz(X, k, D)  # Wyszukujemy drzewo s...
  # Porównujemy wielkości z opracowania...
  if koszt[k - 1] + C[k] < koszt[s] + P[k - 1] - P[s]:
    koszt[k] = koszt[k - 1] + C[k]
    podpowiedz[k] = -1  # ...jeśli jesteś przy k-tym drzewie, wytnij je.
  else:
    # ...jeśli jesteśm przy k-tym drzewie...
    koszt[k] = koszt[s] + P[k - 1] - P[s]
    # ...pozostaw je, wytnij kolejne do s-tego.
    podpowiedz[k] = s

print(koszt[N])  # Mamy już wynik...
wycinka = []
j = N            # Odtwarzamy rozwiązanie cofając się od N:
while j > 0:
  if podpowiedz[j] == -1:  # Jeśli podpowiedź to -1...
    wycinka.append(j)      # ...j-te drzewo do wycinki
    j -= 1                 # ...a my cofamy się do drzewa j-1.
  else:
    s = podpowiedz[j]      # Jeśli podpowiedź to s>0...
    j -= 1
    while j > s:           # ...wycinamy od j-1 do s+1...
      wycinka.append(j)    # ...i cofamy się do s.
      j -= 1

print(len(wycinka))
for drzewo_do_wyciecia in wycinka:
  print(drzewo_do_wyciecia, end=' ')
print()
